% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
%
% boot loader splash code
%
% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


% Boot loader splash areas to uncover.
%
/bsplash.areas [
  [   0   0  160  44  320 320 ]
  [ 320   0  160  44  320 320 ]
  [ 640   0  160  44  320 320 ]
  [  10 320  170 360   48  48 ]
  [  58 320  208 360   48  48 ]
  [ 106 320  246 360   48  48 ]
  [ 154 320  284 360   28  48 ]
  [ 182 320  302 360   40  48 ]
  [ 222 320  332 360   28  48 ]
  [ 250 320  350 360   44  48 ]
  [ 294 320  384 360   44  48 ]
  [ 338 320  418 360   48  48 ]
  [  14 370  174 410   14  14 ]
  [  38 370  198 410   14  14 ]
  [  56 370  216 410   14  14 ]
  [  78 370  238 410   14  14 ]
  [ 110 370  270 410   14  14 ]
  [ 130 370  290 410   14  14 ]
  [ 166 370  326 410   14  14 ]
  [ 188 370  348 410   14  14 ]
  [ 208 370  368 410   14  14 ]
  [ 228 370  388 410   14  14 ]
  [ 250 370  410 410   14  14 ]
  [ 270 370  430 410   14  14 ]
  [ 290 370  450 410   14  14 ]
] def


% Generate pseudo random number.
% Good enough for boot loader splash screen.
%
% ( ) ==> ( int )
%
/rand {
  rand.seed dup _undef eq exch 0 eq or { /rand.seed time 1 add def } if
  rand.seed dup 6 shr over 30 shr xor 1 and
  exch 1 shl or 0x7fffffff and
  /rand.seed over def
} def

% Show boot loader splash.
%
% ( ) ==> ( )
%
/bsplash.show {
  1 activateimage loadpalette
  /max_image_colors max_image_colors image.colors max def

  -1 -1 0 fillmode
  0 0 moveto getpixel dup settransparentcolor setcolor
  0 0 moveto screen.size fillrect
  700000 usleep

  0 1 2 {
    bsplash.areas exch get
    dup 2 get over 3 get moveto
    dup 0 get exch dup 1 get exch dup 4 get exch 5 get image
    700000 usleep
  } for
  200000 usleep

  9 -1 1 {
    rand over mod 3 exch over add 3 1 roll add 1 sub
    over bsplash.areas exch get
    dup 2 get over 3 get moveto
    dup 0 get exch dup 1 get exch dup 4 get exch 5 get image
    bsplash.areas exch get bsplash.areas 3 1 roll put
    50000 usleep
  } for

  13 -1 1 {
    rand over mod 12 exch over add 3 1 roll add 1 sub
    over bsplash.areas exch get
    dup 2 get over 3 get moveto
    dup 0 get exch dup 1 get exch dup 4 get exch 5 get image
    bsplash.areas exch get bsplash.areas 3 1 roll put
    50000 usleep
  } for
  50000 usleep

  0 2 20 {
    426 over 64 add moveto
    426 exch 330 add 32 2 image
    30000 usleep
  } for

  2000000 usleep
  0 activateimage
  -1 settransparentcolor
} def


% Just wait.
%
% ( ) ==> ( )
%
/bsplash.done {
} def
